{
      http://melfis.ru/    
       .  DSPack 
         http://melfis.ru/     
http://www.progdigy.com/.
}

unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DSPack, DSUtil, DirectShow9, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    FilterGraph1: TFilterGraph;
    VideoWindow1: TVideoWindow;
    Filter1: TFilter;
    SampleGrabber1: TSampleGrabber;
    Timer1: TTimer;
    Memo1: TMemo;
    Image1: TImage;
    Image2: TImage;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CamItem: TSysDevEnum;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked = true then
    Timer1.Enabled:=true
  else
    Timer1.Enabled:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
begin
  CamItem:= TSysDevEnum.Create(CLSID_VideoInputDeviceCategory);

  if CamItem.CountFilters > 0 then
  begin
    FilterGraph1.ClearGraph;
    FilterGraph1.Active:=false;
    //      
    //0          CamItem.CountFilters
    Filter1.BaseFilter.Moniker:=CamItem.GetMoniker(0);
    FilterGraph1.Active:=true;

    //    .
    with FilterGraph1 as ICaptureGraphBuilder2 do
    //RenderStream(@PIN_CATEGORY_PREVIEW, nil, Filter1 as IBaseFilter, SampleGrabber1 as IBaseFilter, VideoWindow1 as IbaseFilter);
    RenderStream(@PIN_CATEGORY_PREVIEW, nil, Filter1 as IBaseFilter, SampleGrabber1 as IBaseFilter, VideoWindow1 as IbaseFilter);

    //   .
    FilterGraph1.Play;
  end;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
//i-   
i:integer;

//j-   
j:integer;

//  
k:integer;
r1,g1,b1:Byte;
r2,g2,b2:Byte;
FirstColor,SecondColor:Integer;
Color:TColor;
ChangeDetect:byte;
begin

//  
if Timer1.Tag=0 then
begin
  SampleGrabber1.GetBitmap(Image1.Picture.Bitmap);
  Timer1.Tag:=1;
  exit;
end;

//   - ,    
SampleGrabber1.GetBitmap(Image2.Picture.Bitmap);
Timer1.Tag:=0;
k:=0;

//  
for i := 1 to Image1.Picture.Bitmap.Height do
begin
  for j := 1 to Image1.Picture.Bitmap.Width do
    begin
      ChangeDetect:=0;

      //     
      FirstColor:=Image1.Picture.Bitmap.Canvas.Pixels[i,j];

      //  RGB

      r1:=GetRValue(FirstColor);
      g1:=GetGValue(FirstColor);
      b1:=GetBValue(FirstColor);

      SecondColor:=Image2.Picture.Bitmap.Canvas.Pixels[i,j];

      r2:=GetRValue(SecondColor);
      g2:=GetGValue(SecondColor);
      b2:=GetBValue(SecondColor);

      //     

      if Abs(r1-r2)>20 then inc(ChangeDetect);
        if Abs(g1-g2)>20 then inc(ChangeDetect);
          if Abs(b1-b2)>20 then inc(ChangeDetect);
            //  ,   
            if ChangeDetect=3 then k:=k+1;
              Application.ProcessMessages;
end;
end;

//   1500    
if k>1500 then
begin
  Memo1.Lines.Add(FormatDateTime('hh:nn:ss',Now)+'  !');
  Image2.Picture.Bitmap.SaveToFile('alerts\'+FormatDateTime('hhnnss',Now)+'.bmp');
end;

end;

end.
